Тёмный

Dynamic Programming with Java - Learn to Solve Algorithmic Problems & Coding Challenges 

freeCodeCamp.org
Подписаться 10 млн
Просмотров 133 тыс.
50% 1

Опубликовано:

 

21 сен 2024

Поделиться:

Ссылка:

Скачать:

Готовим ссылку...

Добавить в:

Мой плейлист
Посмотреть позже
Комментарии : 107   
@aanchaallllllll
@aanchaallllllll Год назад
0:00: 💡 Dynamic programming is a method for solving complex problems by breaking them down into simpler overlapping subproblems and storing solutions to avoid redundant computations. 10:37: 🌳 The complexity of the recursive solution is very large and difficult to analyze due to the asymmetry of the tree. 21:27: 📝 The process involves calculating Fibonacci numbers and storing them in a memo to avoid redundant calculations. 32:21: ⏰ By implementing memoization, the time complexity of the solution improves to O(n). 43:20: ⏱ The code is too slow and needs memoization to improve its speed. 53:19: 📊 Implementing memoization strategy in a recursive algorithm can reduce the exponential complexity to linear complexity. 1:03:37: 💰 The goal is to find the minimum number of coins required to reach a target amount. 1:13:54: 🔑 The approach is to optimize for the number of coins needed to create a given amount. 1:24:17: 🌳 The problem can be represented as a tree, where each node represents a possible path in the grid. 1:34:31: 🔢 The code is implementing a recursive function to count the number of paths to a goal position. 1:45:46: 🔍 The code sets up a method to track a position in a grid and checks for base cases. 1:56:26: 🌳 The problem at hand involves a dynamic programming approach to finding duplicate subtrees in a larger tree. 2:06:57: 🔑 The code snippet describes the implementation of memoization in a recursive method using a hashmap. 2:17:21: 🔍 The code is finding the minimal sum of squares using a recursive helper method. 2:28:23: 🔢 The Java walkthrough for the counting change problem involves implementing a recursive method with an additional argument. Recap by Tammy AI
@Legacyposh
@Legacyposh Год назад
Thanks so much
@dkdraipur
@dkdraipur Год назад
The best ever tutorial make on DP. Using HashMap removes all the ambiguity around the DP. Kudos
@justindouglas3659
@justindouglas3659 Год назад
Finally something i can use to learn. Thank you so much.
@sidharth-singh
@sidharth-singh 11 месяцев назад
I struggled with Dynamic Programming for past 3 years. This video is amazing! By the half of it, I was already on my way solving them. I like the last one. It was a different variety in itself. I thought of a solution actually storing the paths in a "Set" and then count the length of the "Set". I never thought of this way for this problem . Even though choosing or not choosing is a common pattern in recursion. THNAK YOU SO MUCH!!
@pleasantdayNwisdom
@pleasantdayNwisdom 5 месяцев назад
bhai maene bhi itna acha dp course nhi dekha , striver etc were not teaching simple way , mera yeh feel aaya , i saw his approach for 2 problems and then own my own till the last one ,stuck ho gya hu , mae bhi set wala hi soch rha hu , but pta h kuch better way ho skta h , i want to do this last question on my own
@MyCodingDiary
@MyCodingDiary Год назад
You're doing an amazing job at explaining coding concepts. Keep up the great work!
@zakariaelmoumnaoui4912
@zakariaelmoumnaoui4912 Год назад
Finally Java this time
@gradientO
@gradientO Год назад
It's concepts that are important, not the language
@Ganesan4510
@Ganesan4510 Год назад
Python onlyone
@Carlos-kv6hx
@Carlos-kv6hx Год назад
I agree but like 90% of content is web dev here
@-karter-4556
@-karter-4556 Год назад
@@gradientO there is memoric value in applying concepts in an already familiar programming language.
@Saiyan412
@Saiyan412 11 месяцев назад
Yup 👍🏻
@lawalrasheed_
@lawalrasheed_ 11 месяцев назад
This is absolutely elite, thanks for making this available to the community for free. Just to build on this for learners here, you probably want to explore an iterative solution to the "non-adjacent sum" since large array inputs will blow up your call stack in the recursive approach.
@allanguwatudde7623
@allanguwatudde7623 9 месяцев назад
You mean bottom-up?
@bcampera
@bcampera 6 месяцев назад
Man there are great vids out there but you're the only one that made me really understand this in a simple manner, I don't feel stupid any more. Thank you so much!
@arnavsharma2094
@arnavsharma2094 Год назад
I would like to say thank you to the instructor for providing this knowledge for free on this platform
@Yash42189
@Yash42189 Год назад
this is such a fascinating way of solving problems! I love it!
@thusith-tec307
@thusith-tec307 Год назад
Wow... Java. Thank you
@leomamaci376
@leomamaci376 Год назад
Finally Java, been waiting for it so long 🎉
@RodrigoRocha1980
@RodrigoRocha1980 Год назад
### Resumo Neste conteúdo, Alvin Zablin ensina sobre programação dinâmica, com foco em resolver problemas de Fibonacci de forma recursiva com memoização. Ele começa explicando os conceitos básicos da programação dinâmica e o problema de Fibonacci. Em seguida, ele mostra como resolver o problema de Fibonacci de maneira recursiva, incluindo base cases para 0 e 1. Além disso, ele introduz a estratégia de memoização, onde os resultados são armazenados para evitar cálculos duplicados e melhora o desempenho. Alvin também discute a complexidade de tempo e espaço do algoritmo, destacando a eficiência da abordagem de memoização. ### Destaques - 📚 Programação dinâmica é usada para resolver problemas complexos quebrando-os em subproblemas sobrepostos e armazenando soluções para evitar cálculos redundantes. - 🧮 O problema de Fibonacci é um exemplo clássico usado para entender a programação dinâmica. - 🤖 Alvin Zablin ensina como resolver o problema de Fibonacci de forma recursiva, com base em base cases para 0 e 1. - 📊 A estratégia de memoização envolve armazenar resultados para evitar recalculos, melhorando o desempenho. - 🕰 A complexidade de tempo do algoritmo de Fibonacci com memoização é O(n), enquanto a complexidade de espaço é O(n), tornando-o eficiente.
@carloseduard317
@carloseduard317 Год назад
Amazing lesson Teacher! Than'k!
@pleasantdayNwisdom
@pleasantdayNwisdom 5 месяцев назад
Thankyou Alvin Sir , I did Sum possible problem on my own , saw many recommended playlist on dp , but ur way of explanation worked for me ! Happy ! thankyou code camp :) but one slight doubt , like for this question sum possible , suppose if zero digit is required for amount =0 , then what would have been the base case?
@CodingAlways
@CodingAlways Год назад
I love your lectures... ❤️🥰
@aammssaamm
@aammssaamm Год назад
This is what needs to be used for the frontend components. Then the communication between components and branches is a breeze. You can send any event with any data to any point and fully control the sequence of those threads at any time. Then components have to be the object of the same class and share the same methods of communication.
@vedangarekar1390
@vedangarekar1390 Год назад
Can you explain using examples of where this is used in frontend ?
@aammssaamm
@aammssaamm Год назад
@@vedangarekar1390 All frontend components should be organized in one tree which becomes a bus for communication between them. The simplest example is the DOM itself, but components may be more complex that just a single HTML tag. HTML becomes a template only for a component. There should be a common class “component/widget/actor”, which all component objects of different types are created from. The best way to understand is the Actor Model by Carl Hewitt. You can google “actor model javascript” to see various examples.
@jayjaayjaaay94
@jayjaayjaaay94 8 месяцев назад
I don't understand count paths problem, you use c== grid.get(0).size() which actually get the right top? 🤔 🤔 Shouldn't we check the right bottom of the grid? c==grid.get(grid.size() - 1).size() Please help me
@sammetanagasrinivas5542
@sammetanagasrinivas5542 10 месяцев назад
Thanks for the video, I really got an idea about DP
@mihu86
@mihu86 11 месяцев назад
In the "max path sum" problem using double is not necessarily a good idea. Although it would require an extremely large grid with large numbers to fail, theoretically it can fail due to number representation / precision issues, especially as a "rolling sum" is being calculated (well, to be honest, this would require a long in the "main method" instead of int - but one should still think about these potential issues, that is the important bit here). It would have been more straightforward to simply use Integer.MIN_VALUE (or in case of really big inputs, Long. MIN_VALUE) in the initialization. (The performance can be slightly better as well for a really big input.)
@minhtriettruong9217
@minhtriettruong9217 Год назад
Alvin lets goooo!!!
@icarus7247
@icarus7247 Год назад
Thanks
@sathishkumar-rc4se
@sathishkumar-rc4se Год назад
In the Sum Possible Challenge he has added the Memo Hashmap inside the If Condition (1:03:45), In general if the Condition is met then the it return the value as True and Loop ends whats the Point in adding the Memo HashMap inside that Condition!
@Yash42189
@Yash42189 Год назад
here is chatgpt's answer Yes, you're right. Once any branch returns true, the answer for the top-level problem has been found, and you can halt further exploration. Any subsequent or sibling branches don't need to be explored. The recursive call stack will unwind, and true will propagate all the way up, ultimately indicating that the target sum can be achieved with the given numbers. The value in memoizing the result (true or false) for a specific target is to handle situations where you're exploring other potential branches or paths before you find one that leads to a solution. Memoization can also be beneficial if you're solving different instances of the problem (e.g., checking for multiple different target values) during the program's execution. However, within the context of a single invocation and after finding a valid combination, you're right that the memoized values won't be accessed since you'd halt the process and return true. If you're focused on optimizing purely for the scenario where you halt immediately upon finding a solution, you can indeed skip memoizing the true result in the current context, since it won't be accessed again. The key is understanding the trade-offs and tailoring the approach to the specific requirements and constraints of the situation at hand.
@itsSunnyy0
@itsSunnyy0 29 дней назад
exactly, the main idea is false memos can save a few recursive calls, if its true it just returns so no point in caching.
@jayjaayjaaay94
@jayjaayjaaay94 8 месяцев назад
I don't understand, in count path problems, why it check c== grid.get(0).size? Isn't checking right top? 🤔 Shouldn't we check the right bottom? Which is c== grid.get(grid.size - 1).size?
@susantamandal2782
@susantamandal2782 4 месяца назад
I was going through the Non Adjacent Sum Tree structure and found some of the portions are getting missed. I was looking for any better explanation. 1:57:00
@manipurihunabopa
@manipurihunabopa 10 месяцев назад
Great tutorial because everything taught here is easy or made easy to understand.
@amalayounes
@amalayounes 6 месяцев назад
This is amazing stuff!! Thank you so much.
@hend3gossate
@hend3gossate 2 месяца назад
besides dynamic programming we can traverse answer tree like bfs instead of dfs
@tahitivn
@tahitivn 3 месяца назад
view on many videos, this is easier to understand concepts
@chovuse
@chovuse 11 месяцев назад
Great tutorials ! Please make your syntax text larger. Many Thanks !!!
@RaviKumar-v9b6m
@RaviKumar-v9b6m Год назад
Non adjacent problem I think we can easily solve using For loop
@fieryscorpion
@fieryscorpion Год назад
Can you please do this using C# as well? Show some love to C#. It’s such a nice language.
@fumano2679
@fumano2679 9 месяцев назад
Hey found here through advent of code 2023 day 12 part 2. Greetings :)
@ForRo3sS
@ForRo3sS 3 месяца назад
This is good
@ka1pana
@ka1pana 9 месяцев назад
The 0 base case in the Sum possible problem, qualifies as "true" is not clear. Question was are there ways of using the numbers given to add up to the amount. If Amount 0, and numbers are 1, 2, 3 we cannot use any of the numbers to add to 0 (assuming all numbers are positive), so the answer is false right ?
@ShubhangiDutta
@ShubhangiDutta 9 месяцев назад
I think that its referring to case where the amount can be made without choosing any option for the list- so even if you have say 1, 2 and 3, you can always make 0 by never adding any of them, hence true. The same applies to the minChange problem.
@theencryptedpartition4633
@theencryptedpartition4633 Год назад
YASSS. I was doing my research paper or project on it just this term
@RakeshPulioffical
@RakeshPulioffical Год назад
can you please upload videos on power BI you're channel is best learning resource for us
@jishnuanchery
@jishnuanchery Год назад
this is really good. Thank you!
@anon-fz2bo
@anon-fz2bo Год назад
hell yea i love dynamic programming
@santhoshjoruka2036
@santhoshjoruka2036 6 месяцев назад
In the count paths problem how did you come up with this logic countPaths(r + 1, c, grid, memo) + countPaths(r, c + 1, grid, memo)? anyone who understands can help on this.
@yourpoookieboo
@yourpoookieboo 7 месяцев назад
Half way through, i get the sums clearly cus of the tree based visualisation for dp or recursion nice hack there, however the count paths sum could have been a bit more in depth , anyway kudos
@ankitg6454
@ankitg6454 6 месяцев назад
Many many thanks
@conphident4
@conphident4 11 месяцев назад
Thanks!
@muradmemmedov1055
@muradmemmedov1055 26 дней назад
In your implementation(tribonacci), n(0) and n(1) both return 0, which is incorrect. n(1) should return 1 @alvinzablan
@kwaleyelamusilizoikafa6197
@kwaleyelamusilizoikafa6197 Год назад
More Java content please
@-karter-4556
@-karter-4556 Год назад
Finallyyyy!!!!
@rebelgirl3107
@rebelgirl3107 4 месяца назад
Sir, I have a question about dynamic programming, how can I reach you?
@vidhikaushik738
@vidhikaushik738 Год назад
Oh my god I am struggling with these kinds of problems and you heard it 😂😂
@faroukzouaimia2494
@faroukzouaimia2494 Год назад
Is there one in c++
@johncysamuel
@johncysamuel Год назад
Thanks👍❤🙏
@MarouanBoukli
@MarouanBoukli 6 месяцев назад
1:18:00 doesn't the minCoins get overwritten every time?
@ovskihouse5270
@ovskihouse5270 Год назад
I wish do it with JS or Python
@alexjohnson6192
@alexjohnson6192 Год назад
the concepts are way more important than the language implementation
@raghavamorusupalli7557
@raghavamorusupalli7557 10 месяцев назад
To demonstrate a solution to the min change problem the selected problem instance must be so typical that the application of greedy method fails on it.
@soumadip_skyy_banerjee
@soumadip_skyy_banerjee Год назад
👌🏻
@Sisyphus3.14
@Sisyphus3.14 Год назад
tutorial hell
@Robo_Mark-8
@Robo_Mark-8 Год назад
good for beginners bad for intermediate 😂😂
@Daydream_Dynamo
@Daydream_Dynamo Год назад
Next up with Python, !!
@forheuristiclifeksh7836
@forheuristiclifeksh7836 2 месяца назад
3:23
@silentworldsound
@silentworldsound Год назад
Hello freeCodeCamp how are you I hope you all are well, One request Please make an "Object-C" mobile app development crash course please, Thanks;
@_sf_editz1870
@_sf_editz1870 Год назад
Please make trees and graphs in java please
@aammssaamm
@aammssaamm Год назад
If you cannot follow even a simple example, you'd better look for a simpler career.
@_sf_editz1870
@_sf_editz1870 Год назад
@@aammssaamm thank you
@wilfredomartel7781
@wilfredomartel7781 Год назад
@CodingAlways
@CodingAlways Год назад
Hiii
@killeredits4400
@killeredits4400 Год назад
Hey hii.....I want complete begginer level to high DynamicProgramming DSA in python....
@Max-tq1ig
@Max-tq1ig Год назад
Your mustache is gone, Alvin!
@GhithEdlbi
@GhithEdlbi Год назад
Is this for beginner ?
@lovely-shrubbery8578
@lovely-shrubbery8578 Год назад
No, its an upper intermediate computer science topic.
@amaanullah13
@amaanullah13 Год назад
No
@Travelophile
@Travelophile 5 месяцев назад
this will fail for input [1,2,5] , due to the memoization
@neilclay5835
@neilclay5835 Год назад
Too many "rights". It's a common problem.
@keineangabe8993
@keineangabe8993 Год назад
The lecturer probably knows this, but i cant watch a video where somebody uses an explicit HashMap in a method signature. Makes me wonder which other bad principles are included that i might not notice.
@jagi7976
@jagi7976 Год назад
What do you suggest instead?
@keineangabe8993
@keineangabe8993 Год назад
@@jagi7976 always use interface types, so in this case Map. It doesnt matter if it does not make a difference in this specific case. Some things need to be like muscle memory.
@Yash42189
@Yash42189 Год назад
so you have nothing good to say about this great, free lecture? What principles dude, he isn't writing enterprise solutions. It is just a single method. You want him to use dependency injeciton too?
@keineangabe8993
@keineangabe8993 Год назад
@@Yash42189 Dependency injection would include unnecessary complexion. Using an interface would not, it barely changes what he would have to write. And no, i have nothing good to say because i did not watch it after that, as i already said.
@tarundjremix2323
@tarundjremix2323 Год назад
Wait, do you think cryptocurrency will crash? I dont think so. More and more companies are integrating cryptocurrency into their operations: Amazon, Cannafarm Ltd, Burger King, even Starbucks, dude!
@CodingAlways
@CodingAlways Год назад
My name is bikram barman... From India West Bengal
@souvikghosh5768
@souvikghosh5768 Год назад
Kolkata?
@wildarmy1861
@wildarmy1861 Год назад
I dont know, dudes. I think crypto and all these ICOs are just a bubble. Well, crypto is good for transfers and so on, but I dont engage in trading and staking either. Its too risky. My friend recently lost $5000 there. I invest crypto in real business
@TVSh0rts
@TVSh0rts Год назад
Java is great language, but not for coding interviews come on...
@sadiulhakim7814
@sadiulhakim7814 3 месяца назад
Thanks
@davidchang3252
@davidchang3252 11 месяцев назад
Thanks!
@mdhossen7082
@mdhossen7082 Год назад
Hello freeCodeCamp how are you I hope you all are well, One request please make an "Object-C" mobile app development crash course please, Thanks;
Далее
AI can't cross this line and we don't know why.
24:07
Просмотров 736 тыс.
LIFEHACK😳 Rate our backpacks 1-10 😜🔥🎒
00:13
Faster than Rust and C++: the PERFECT hash table
33:52
Просмотров 570 тыс.
How I would learn Leetcode if I could start over
18:03
Просмотров 526 тыс.
How To Think Like A Programmer
1:00:07
Просмотров 2 млн
Solving Wordle using information theory
30:38
Просмотров 10 млн
How I Mastered Data Structures and Algorithms
10:45
Просмотров 178 тыс.
How to Solve ANY LeetCode Problem (Step-by-Step)
12:37
Просмотров 221 тыс.
LIFEHACK😳 Rate our backpacks 1-10 😜🔥🎒
00:13